package org.eurekaj.btracers;

import com.sun.btrace.annotations.*;
import com.sun.btrace.aggregation.*;
import static com.sun.btrace.BTraceUtils.*;
import java.util.Deque;

@BTrace public class CustomBtracer {
	
	@TLS private static Aggregation TOTAL_EXEC_TIME = newAggregation(AggregationFunction.SUM);
	@TLS private static Aggregation MIN_TIMESTAMP = newAggregation(AggregationFunction.MINIMUM);
	@TLS private static Aggregation CALLS_PER_INTERVAL = newAggregation(AggregationFunction.COUNT);

	@OnTimer(4000)
    public static void printMem() {
        print("Heap:");
        println(heapUsage());
        print("Non-Heap:");
        println(nonHeapUsage());
		
		print("NUM_THEADS: ");
		print(threadCount()); print(" ");
		print(peakThreadCount()); print(" ");
		print(totalStartedThreadCount()); print(" ");
		println(daemonThreadCount());
    }
	
	@OnMethod(
        clazz="/org\\.jsflot\\..*/",
        method="/^[a-zA-Z0-9]+$/", location=@Location(Kind.RETURN)
    )
	public static void after(@Duration long dur, @ProbeMethodName String probeMethod, @ProbeClassName String probeClass) {
		print("CLASS: ");
		print(probeClass);
		print(" ");
		print(probeMethod);
		print(" ");
		print(dur);
		/*AggregationKey k = newAggregationKey(probeClass, probeMethod);

		addToAggregation(TOTAL_EXEC_TIME, k, dur);
		addToAggregation(CALLS_PER_INTERVAL, k, 1); */
	}
	
	@OnTimer(7500)
    public static void printAverage() {
	//DefaultAgent org.ajax4jsf.javascript.ImageCacheScript getJavaScript timemillis callsPerInterval average Classtype path
		println("----------------TOTAL_EXEC_TIME---------------------");
		printAggregation("TOTAL_EXEC_TIME: ", TOTAL_EXEC_TIME);
		
		println("------------------TIMESTAMP-----------------------");
		printAggregation("TIMESTAMP: ", MIN_TIMESTAMP);
		
		println("------------------CALLS_PER_INTERVAL-----------------------");
		printAggregation("CALLS_PER_INTERVAL: ", CALLS_PER_INTERVAL);	
		
		//AgentName package.name.ClassName method timestamp execTime callsPerInterval ClassType Path
		//printEurekaJAggregation()
		
		truncateAggregation(TOTAL_EXEC_TIME, 0);
		truncateAggregation(MIN_TIMESTAMP, 0);
		truncateAggregation(CALLS_PER_INTERVAL, 0);
    }
}